#include <stdio.h>


// Symmetric Elements, Empty Columns, Greater First Than Last Rows

bool CreateMatrix ( double **Matrix, int *Size)
{
	int Range;
	double *Mat;

	printf("\nEnter the range of the matrix [max. 250] : ");
	scanf("%d",&Range);

	if (Range > 250)
	{
		printf("Zbyt duzy rozmiar macierzy.\n\n");
		return false;
	}

	printf("\nEnter the values row by row : \n");

	Mat = new double[Range * Range];

	*Size = Range;
	*Matrix = Mat;

	for (int i = 0; i < Range * Range; i++)
		scanf("%lf", Mat++);

	return true;
}



// Tab[i][j] == Tab[j][i]

int SymmetricElements ( double *Matrix, int Size)
{
	int Sym = 0;

	for (int row = 0; row < Size; row++)
		for (int col = row + 1; col < Size; col++)
			if (*(Matrix + row * Size + col) == 
				*(Matrix + col * Size + row))
					Sym++;

	return Sym;
}


// Tab[N][j] == 0

int EmptyColumns ( double *Matrix, int Size)
{
	int Emp = 0;
	bool Flag; 

	for (int col = 0; col < Size; col++)
	{
		Flag = true;

		for (int row = 0; row < Size && Flag; row++)
			if (*(Matrix + row * Size + col) != 0)
				Flag = false;

		if (Flag)
			Emp++;
	}

	return Emp;
}

// Tab[N][0] > Tab[N][Rozmiar - 1]

int GreaterFirstThanLastRows ( double *Matrix, int Size )
{
	double *Tmp = Matrix;
	int Gr = 0;
 	
	for ( ; Tmp < Matrix + Size * Size; Tmp += Size)
		if ( *Tmp > *(Tmp + Size - 1))
			Gr++;

	return Gr;
}


void main( )
{
	int Size;
	double *Matrix;

	int Results[3];

	int (*TabFun[ ]) (double* , int) = 
		{ SymmetricElements, EmptyColumns, GreaterFirstThanLastRows };

	char* Names[ ] =
		{ "\nSymmetricElements       ", 
		  "\nEmptyColumns            ",
		  "\nGreaterFirstThanLastRows" };
 

	if (!CreateMatrix ( &Matrix, &Size ))
		return;

	
	for (int w = 0; w < 3; w++)
		Results[w] = TabFun[w](Matrix, Size);

	for (w = 0; w < 3; w++)
		printf("%s = %d", Names[w], Results[w]);

	printf("\n\n");

}


			

	
